## kbtin 1.0.26

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.12)
	cmake_policy(SET CMP0075 NEW) # hush the warning, either option works
endif()
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.19)
	cmake_policy(SET CMP0110 NEW)
endif()
project(kbtin C)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckFunctionExists)
include(FindIconv)
include(FindGnuTLS)
include(GNUInstallDirs)

unset(VERSION)
execute_process(COMMAND ./get_version
	OUTPUT_VARIABLE SRCVERSION
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
	OUTPUT_STRIP_TRAILING_WHITESPACE
)

if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "RelWithDebInfo")
endif (NOT CMAKE_BUILD_TYPE)

option(MCCP "MCCP compression via zlib" ON)
option(SSL "SSL encryption via gnutls" ON)
set(DATA_PATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATADIR}/kbtin"
	CACHE PATH "Directory for data (currently help file)")

set(CMAKE_C_FLAGS "-Wall -Werror=format-security ${CMAKE_C_FLAGS}")

set(libs m)

CHECK_INCLUDE_FILES(pty.h HAVE_PTY_H)
CHECK_INCLUDE_FILES(libutil.h HAVE_LIBUTIL_H)
CHECK_INCLUDE_FILES(util.h HAVE_UTIL_H)
CHECK_LIBRARY_EXISTS(util openpty "" HAVE_LIB_UTIL)
if (HAVE_LIB_UTIL)
	set(CMAKE_REQUIRED_LIBRARIES util)
	set(libs ${libs} util)
endif()

CHECK_INCLUDE_FILES(valgrind/valgrind.h HAVE_VALGRIND_VALGRIND_H)
CHECK_INCLUDE_FILES(unistd.h HAVE_UNISTD_H)
CHECK_INCLUDE_FILES(termios.h HAVE_TERMIOS_H)
CHECK_INCLUDE_FILES(stropts.h HAVE_STROPTS_H)
CHECK_FUNCTION_EXISTS(openpty HAVE_OPENPTY)
CHECK_FUNCTION_EXISTS(regcomp HAVE_REGCOMP)
CHECK_FUNCTION_EXISTS(grantpt HAVE_GRANTPT)
CHECK_FUNCTION_EXISTS(getpt HAVE_GETPT)
CHECK_FUNCTION_EXISTS(ptsname HAVE_PTSNAME)
CHECK_FUNCTION_EXISTS(forkpty HAVE_FORKPTY)
CHECK_FUNCTION_EXISTS(cfmakeraw HAVE_CFMAKERAW)
CHECK_FUNCTION_EXISTS(_getpty HAVE__GETPTY)
CHECK_FUNCTION_EXISTS(posix_openpt HAVE_POSIX_OPENPT)
CHECK_FUNCTION_EXISTS(strlcpy HAVE_STRLCPY)
CHECK_FUNCTION_EXISTS(wcwidth HAVE_WCWIDTH)

if(Iconv_FOUND)
	include_directories(SYSTEM ${Iconv_INCLUDE_DIRS})
	set(libs ${libs} ${Iconv_LIBRARY})
else()
	message(FATAL_ERROR "libiconv is required")
endif()

if (MCCP)
	CHECK_LIBRARY_EXISTS(z gzread "" HAVE_LIB_ZLIB)
	if (NOT HAVE_LIB_ZLIB)
		message(FATAL_ERROR "MCCP compression requires zlib")
	endif()
	set(HAVE_ZLIB 1)
	set(libs ${libs} z)
else()
	unset(HAVE_ZLIB)
endif()

if (SSL)
	if (NOT GNUTLS_FOUND)
		message(FATAL_ERROR "SSL encryption requires libgnutls")
	endif()
	set(HAVE_GNUTLS 1)
	include_directories(SYSTEM ${GNUTLS_INCLUDE_DIR})
	set(libs ${libs} ${GNUTLS_LIBRARIES})
else()
	unset(HAVE_GNUTLS)
endif()

configure_file(config.h.cmake ${CMAKE_BINARY_DIR}/config.h)
include_directories(${CMAKE_BINARY_DIR})

set(KBtin_sources
	action.c
	alias.c
	antisub.c
	files.c
	glob.c
	help.c
	highlight.c
	history.c
	eval.c
	llist.c
	main.c
	misc.c
	net.c
	parse.c
	path.c
	session.c
	substitute.c
	ticks.c
	utils.c
	string.c
	events.c
	user.c
	run.c
	colors.c
	routes.c
	bind.c
	telnet.c
	hash.c
	regexp.c
	hooks.c
	unicode.c
	user_pipe.c
	user_tty.c
	wcwidth.c
	chinese.c
	print.c
	ssl.c
	pty.c
	globals.c
	math.c
	slist.c
	lists.c
	vars.c
)

set(protos ${KBtin_sources})
list(TRANSFORM protos REPLACE "([^;]*)\\.c" "${CMAKE_BINARY_DIR}/protos/\\1.h")
add_custom_command(OUTPUT ${protos}
	COMMAND ${CMAKE_SOURCE_DIR}/make_protos ${CMAKE_SOURCE_DIR} ${KBtin_sources}
	DEPENDS make_protos ${KBtin_sources}
	COMMENT "PROTOS")
add_custom_target(protos DEPENDS ${protos})

add_custom_command(OUTPUT commands.h load_commands.h
	COMMAND ${CMAKE_SOURCE_DIR}/make_commands <${CMAKE_SOURCE_DIR}/commands
	DEPENDS commands make_commands
	COMMENT "COMMANDS")
add_custom_target(gen_commands DEPENDS commands.h load_commands.h)

add_executable(KBtin ${KBtin_sources})
add_dependencies(KBtin protos gen_commands)

target_link_libraries(KBtin ${libs})

add_custom_command(OUTPUT manual.html
	DEPENDS KBtin_help
	COMMAND ${CMAKE_SOURCE_DIR}/help2ansi <${CMAKE_SOURCE_DIR}/KBtin_help|${CMAKE_SOURCE_DIR}/a2html|${CMAKE_SOURCE_DIR}/fixmanual >manual.html
	COMMENT "HTML MANUAL")
add_custom_target(manual ALL DEPENDS manual.html)
add_custom_command(OUTPUT KBtin_help.gz
	DEPENDS KBtin_help
	COMMAND gzip -9 <${CMAKE_SOURCE_DIR}/KBtin_help >KBtin_help.gz
	COMMENT "GZIP HELP")
add_custom_target(helpgz ALL DEPENDS KBtin_help.gz)
add_custom_command(OUTPUT kbtin
	DEPENDS KBtin
	COMMAND ln -s KBtin kbtin
	COMMENT "SYMLINK KBTIN")
add_custom_target(symlink_kbtin ALL DEPENDS kbtin)

install(TARGETS KBtin DESTINATION bin)
install(FILES KBtin.6 kbtin.6 DESTINATION ${CMAKE_INSTALL_MANDIR}/man6)
install(FILES ${CMAKE_BINARY_DIR}/KBtin_help.gz DESTINATION ${DATA_PATH})
install(FILES ${CMAKE_BINARY_DIR}/manual.html DESTINATION ${CMAKE_INSTALL_DOCDIR})
install(FILES ${CMAKE_BINARY_DIR}/kbtin DESTINATION bin)

enable_testing()
add_subdirectory(tests)

=== tests/CMakeLists.txt ===
set(CTEST_OUTPUT_ON_FAILURE ON)

add_executable(ttyrec2ansi ttyrec2ansi.c)
add_executable(get-utf8 get-utf8.c)

file(GLOB tests
	LIST_DIRECTORIES false
	CONFIGURE_DEPENDS
	${CMAKE_CURRENT_SOURCE_DIR}/data/*.in)
foreach(t ${tests})
	string(REGEX REPLACE ".*/([^/]*)\\.in$"
		"\\1" t
		${t})
	set(tn "${t}")
	if(CMAKE_VERSION VERSION_LESS 3.19)
		string(REPLACE " " "_" tn "${tn}")
		string(REPLACE "#" "♯" tn "${tn}")
		string(REPLACE "(" "⦅" tn "${tn}")
		string(REPLACE ")" "⦆" tn "${tn}")
	endif()
	add_test(NAME ${tn}
		COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/runtest.sh "${t}")
endforeach()

## kbtin 1.0.14

=== debian/changelog ===
kbtin (1.0.14-1) unstable; urgency=low

  * New upstream release.
  * Convert to dh style debian/rules.
  * Move the main executable to /usr/bin, as some secondary uses have a valid
    reason to be run by root.
  * Initial Debian release (closes: #213361).

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 23 Dec 2012 18:10:01 +0100

kbtin (1.0.13.1-2) unstable; urgency=low

  * Fix testsuite failure on chroots with unset time zone.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 13 May 2010 23:07:55 +0200

kbtin (1.0.13.1-1) unstable; urgency=low

  * New upstream release (irrelevant to Debian).

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 25 Jul 2009 05:19:02 +0200

kbtin (1.0.13-1) unstable; urgency=low

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 20 Jun 2008 17:11:37 +0200

kbtin (1.0.12-1) unstable; urgency=low

  * New upstream release
  * Delete config.{guess,sub,rpath}, use them from autotools-dev and gettext.
  * Move main binaries to /usr/games.
  * ... but not log converters.  Hush lintian's warning about this.

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 15 Mar 2008 02:52:25 +0100

kbtin (1.0.11-1) unstable; urgency=low

  * New upstream release.
  * Man pages are updated.

 -- Adam Borowski <kilobyte@angband.pl>  Tue,  4 Sep 2007 03:16:56 +0200

kbtin (1.0.10svn89-1) unstable; urgency=low

  * New SVN pull.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 21 Jun 2007 01:13:04 +0200

kbtin (1.0.10-1) unstable; urgency=low

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 02 Jun 2007 13:10:45 +0200

kbtin (1.0.9-1) unstable; urgency=low

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 24 Feb 2007 19:13:48 +0100

kbtin (1.0.8-1) unstable; urgency=low

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 11 Nov 2006 18:52:43 +0100

kbtin (1.0.7-1) unstable; urgency=low

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Thu,  6 Apr 2006 01:44:41 +0200

kbtin (1.0.6a-1) unstable; urgency=low

  * An upstream regression fix.

 -- Adam Borowski <kilobyte@mimuw.edu.pl>  Thu, 24 Mar 2005 18:39:18 +0100

kbtin (1.0.6-1) unstable; urgency=low

  * New upstream release.

 -- Adam Borowski <kilobyte@mimuw.edu.pl>  Tue, 22 Mar 2005 21:05:33 +0100

kbtin (1.0.5-2) unstable; urgency=low

  * Tossed in a menu icon.

 -- Adam Borowski <kilobyte@mimuw.edu.pl>  Sun,  1 Feb 2004 01:13:43 +0100

kbtin (1.0.5-1) unstable; urgency=low

  * New upstream release.
  * Added menu entry.
  * Included terminfo definition for TERM="KBtin".

 -- Adam Borowski <kilobyte@mimuw.edu.pl>  Mon, 29 Sep 2003 03:15:22 -0400

kbtin (1.0.4-1) unstable; urgency=low

  * Initial SourceForge release.

 -- Adam Borowski <kilobyte@mimuw.edu.pl>  Mon,  5 May 2003 09:31:35 +0200

=== debian/control ===
Source: kbtin
Section: text
Priority: optional
Maintainer: Adam Borowski <kilobyte@angband.pl>
Build-Depends: debhelper (>> 9.0.0), locales, libz-dev, libglib2.0-dev (>= 2.10), gettext, autoconf, autotools-dev, libgnutls-dev
Standards-Version: 3.9.4
Homepage: http://kbtin.sourceforge.net/

Package: kbtin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tintin++ style text-based MUD client
 KBtin is a console MUD client based on the once-popular tintin++.
 It is not limited for mudding, and can be used for running line-based local
 programs like adventure, mysqlclient, dpkg-buildpackage or piuparts.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel

override_dh_auto_build:
	dh_auto_build
	$(MAKE) manual.html

override_dh_auto_test:
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	sh debian/locale-gen
	LOCPATH=$(CURDIR)/locales $(MAKE) check || debian/rules testfail
else
	@echo Suppressing 'make check', because this is a cross build
endif

testfail:
	@echo "!!!TESTS FAILED!!!"
	@cat tests/testsuite.log
	@false

override_dh_auto_install:
	$(MAKE) install DESTDIR=$(CURDIR)/debian/kbtin
	$(MAKE) install-terminfo DESTDIR=$(CURDIR)/debian/kbtin TERMINFODIR=/usr/share/terminfo
	dh_install debian/kbtin.xpm /usr/share/pixmaps/

override_dh_auto_clean:
	rm -rf locales
	rm -f tests/tests.at
	dh_auto_clean

## kbtin 1.0.15

=== debian/changelog ===
kbtin (1.0.15-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rebuild against libgnutls28-dev. Closes: #753100

 -- Andreas Metzler <ametzler@debian.org>  Sun, 03 Aug 2014 16:02:40 +0200

kbtin (1.0.15-1) unstable; urgency=medium

  * New upstream release.
  * Fix FTBFS on big endian (closes: #748228), and on kfreebsd.
  * Force spammy build output.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 15 May 2014 23:10:38 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: text
 Priority: optional
 Maintainer: Adam Borowski <kilobyte@angband.pl>
-Build-Depends: debhelper (>> 9.0.0), locales, libz-dev, libglib2.0-dev (>= 2.10), gettext, autoconf, autotools-dev, libgnutls-dev
-Standards-Version: 3.9.4
+Build-Depends: debhelper (>> 9.0.0), locales, libz-dev, libglib2.0-dev (>= 2.10), gettext, autoconf, autotools-dev, libgnutls28-dev
+Standards-Version: 3.9.5
 Homepage: http://kbtin.sourceforge.net/
 
 Package: kbtin

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 	dh $@ --parallel
 
 override_dh_auto_build:
-	dh_auto_build
+	V=y dh_auto_build
 	$(MAKE) manual.html
 
 override_dh_auto_test:

## kbtin 1.0.16

=== debian/changelog ===
kbtin (1.0.16-2) unstable; urgency=medium

  * Enable hardening=+all, as we do process untrusted network input.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 23 Mar 2016 15:53:06 +0100

kbtin (1.0.16-1) unstable; urgency=medium

  * New upstream release.
  * Make the build reproducible. Closes: #790387
  * Use dh-autoreconf.
  * Drop the debian menu.
  * Use C.UTF-8 for the testsuite instead of bothering with locale generation.
  * Add Vcs-{Git,Browser}.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 09 Dec 2015 17:34:02 +0100

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,12 @@
 Section: text
 Priority: optional
 Maintainer: Adam Borowski <kilobyte@angband.pl>
-Build-Depends: debhelper (>> 9.0.0), locales, libz-dev, libglib2.0-dev (>= 2.10), gettext, autoconf, autotools-dev, libgnutls28-dev
-Standards-Version: 3.9.5
+Build-Depends: debhelper (>> 9.0.0), libz-dev, libglib2.0-dev (>= 2.10),
+ gettext, libgnutls28-dev, dh-autoreconf
+Standards-Version: 3.9.7
 Homepage: http://kbtin.sourceforge.net/
+Vcs-Git: https://github.com/kilobyte/kbtin.git -b debian
+Vcs-Browser: https://github.com/kilobyte/kbtin/tree/debian
 
 Package: kbtin
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --parallel --with autoreconf

override_dh_auto_build:
	V=y dh_auto_build
	$(MAKE) manual.html

override_dh_auto_test:
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	$(MAKE) check || debian/rules testfail
else
	@echo Suppressing 'make check', because this is a cross build
endif

testfail:
	@echo "!!!TESTS FAILED!!!"
	@cat tests/testsuite.log
	@false

override_dh_auto_install:
	$(MAKE) install DESTDIR=$(CURDIR)/debian/kbtin
	$(MAKE) install-terminfo DESTDIR=$(CURDIR)/debian/kbtin TERMINFODIR=/usr/share/terminfo

override_dh_auto_clean:
	rm -f tests/tests.at
	dh_auto_clean

## kbtin 1.0.17

=== debian/changelog ===
kbtin (1.0.17-1) unstable; urgency=medium

  * New upstream release.
  * Split out ansi2html, ansi2txt, ttyrec2ansi, (new) pipetty to a new
    package "colorized-logs".

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 29 Aug 2016 17:12:51 +0200

=== debian/control ===
Source: kbtin
Section: text
Priority: optional
Maintainer: Adam Borowski <kilobyte@angband.pl>
Build-Depends: debhelper (>> 9.0.0), libz-dev, libglib2.0-dev (>= 2.10),
 gettext, libgnutls28-dev, dh-autoreconf
Standards-Version: 3.9.8
Homepage: http://kbtin.sourceforge.net/
Vcs-Git: https://github.com/kilobyte/kbtin.git -b debian
Vcs-Browser: https://github.com/kilobyte/kbtin/tree/debian

Package: kbtin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: colorized-logs
Description: tintin++ style text-based MUD client
 KBtin is a console MUD client based on the once-popular tintin++.
 It is not limited for mudding, and can be used for running line-based local
 programs like adventure, mysqlclient, dpkg-buildpackage or piuparts.

Package: colorized-logs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: kbtin (<< 1.0.17)
Suggests: colordiff, colormake, ccze, colortail
Description: tools for consuming logs with ANSI color
 Some tools like gcc, dmesg, grep --color, colordiff, ccze, etc can enhance
 their output with color, making reading a lot more pleasant.  You can
 usually view that only on your terminal or with "less -R"; this package
 gives you:
  * ansi2html: convert logs to HTML
  * ansi2txt: drop ANSI control codes
  * ttyrec2ansi: drop timing data from ttyrec files
  * pipetty: makes a program think its stdout and stderr are connected to a
    terminal; use as a prefix: "pipetty dmesg|tee"

=== debian/rules ===
--- 
+++ 
@@ -23,6 +23,10 @@
 override_dh_auto_install:
 	$(MAKE) install DESTDIR=$(CURDIR)/debian/kbtin
 	$(MAKE) install-terminfo DESTDIR=$(CURDIR)/debian/kbtin TERMINFODIR=/usr/share/terminfo
+	for x in ansi2txt ansi2html ttyrec2ansi pipetty;do \
+	  mv $(CURDIR)/debian/kbtin/usr/bin/$$x $(CURDIR)/debian/colorized-logs/usr/bin/; \
+        done
+	mv $(CURDIR)/debian/kbtin/usr/share/man/man1 $(CURDIR)/debian/colorized-logs/usr/share/man/
 
 override_dh_auto_clean:
 	rm -f tests/tests.at

=== debian/watch ===
version=3
http://sf.net/kbtin/kbtin-(.+)\.tar\.xz

## kbtin 1.0.18

=== debian/changelog ===
kbtin (1.0.18-3) unstable; urgency=medium

  * Drop Build-Conflicts on fakeroot.

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 21 Jan 2018 23:14:18 +0100

kbtin (1.0.18-2) unstable; urgency=medium

  * R³.
  * Revert correct 256-color palette, makes screen fugly.
  * dh 11.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 18 Jan 2018 00:18:48 +0100

kbtin (1.0.18-1) unstable; urgency=medium

  * New upstream release.
  * Drop colorized-logs, it's a separate source now.
  * Check the tarball's signature.

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 22 Oct 2017 02:15:20 +0200

=== debian/control ===
Source: kbtin
Section: text
Priority: optional
Maintainer: Adam Borowski <kilobyte@angband.pl>
Build-Depends: debhelper (>= 11~), libz-dev, libglib2.0-dev (>= 2.10),
 gettext, libgnutls28-dev
Standards-Version: 4.1.3
Homepage: http://kbtin.sourceforge.net/
Vcs-Git: https://github.com/kilobyte/kbtin.git -b debian
Vcs-Browser: https://github.com/kilobyte/kbtin/tree/debian
Rules-Requires-Root: no

Package: kbtin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: colorized-logs
Description: tintin++ style text-based MUD client
 KBtin is a console MUD client based on the once-popular tintin++.
 It is not limited for mudding, and can be used for running line-based local
 programs like adventure, mysqlclient, dpkg-buildpackage or piuparts.

## kbtin 1.0.19

=== debian/changelog ===
kbtin (1.0.19-2) unstable; urgency=medium

  * Fix cross-building. Closes: #916379

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 04 Feb 2019 18:00:01 +0100

kbtin (1.0.19-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 23 Jul 2018 04:01:27 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Adam Borowski <kilobyte@angband.pl>
 Build-Depends: debhelper (>= 11~), libz-dev, libglib2.0-dev (>= 2.10),
  gettext, libgnutls28-dev
-Standards-Version: 4.1.3
+Standards-Version: 4.3.0
 Homepage: http://kbtin.sourceforge.net/
 Vcs-Git: https://github.com/kilobyte/kbtin.git -b debian
 Vcs-Browser: https://github.com/kilobyte/kbtin/tree/debian

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_build:
	V=y dh_auto_build
	$(MAKE) manual.html

override_dh_auto_test:
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	$(MAKE) check || debian/rules testfail
else
	@echo Suppressing 'make check', because this is a cross build
endif

testfail:
	@echo "!!!TESTS FAILED!!!"
	@cat tests/testsuite.log
	@false

override_dh_auto_install:
	$(MAKE) install DESTDIR=$(CURDIR)/debian/kbtin
	$(MAKE) install-terminfo DESTDIR=$(CURDIR)/debian/kbtin TERMINFODIR=/usr/share/terminfo

override_dh_auto_clean:
	rm -f tests/tests.at
	dh_auto_clean

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ http://sf.net/kbtin/kbtin-(.+)\.tar\.xz

## kbtin 1.0.20

=== debian/changelog ===
kbtin (1.0.20-1) unstable; urgency=medium

  * New upstream release.
  * A simple pkgtest.

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 26 Jan 2020 01:16:28 +0100

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: text
 Priority: optional
 Maintainer: Adam Borowski <kilobyte@angband.pl>
-Build-Depends: debhelper (>= 11~), libz-dev, libglib2.0-dev (>= 2.10),
+Build-Depends: debhelper-compat (=12), libz-dev, libglib2.0-dev (>= 2.10),
  gettext, libgnutls28-dev
-Standards-Version: 4.3.0
-Homepage: http://kbtin.sourceforge.net/
+Standards-Version: 4.5.0
+Homepage: https://github.com/kilobyte/kbtin
 Vcs-Git: https://github.com/kilobyte/kbtin.git -b debian
 Vcs-Browser: https://github.com/kilobyte/kbtin/tree/debian
 Rules-Requires-Root: no

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,10 @@
 
 %:
 	dh $@
+
+override_dh_autoreconf:
+	touch README
+	dh_autoreconf
 
 override_dh_auto_build:
 	V=y dh_auto_build
@@ -26,4 +30,5 @@
 
 override_dh_auto_clean:
 	rm -f tests/tests.at
+	rm -f README README.md .travis.yml
 	dh_auto_clean

## kbtin 1.0.22

=== debian/changelog ===
kbtin (1.0.22-1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 15 Feb 2021 00:33:20 +0100

kbtin (1.0.21-1) unstable; urgency=medium

  * New upstream release.
  * Move the watch file to GitHub.

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 30 Jan 2021 09:50:07 +0100

kbtin (1.0.20-2) unstable; urgency=medium

  * Fix wrong version being displayed.
  * Fix config.rpath sometimes not being recreated.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 07 Apr 2020 19:45:53 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: text
 Priority: optional
 Maintainer: Adam Borowski <kilobyte@angband.pl>
-Build-Depends: debhelper-compat (=12), libz-dev, libglib2.0-dev (>= 2.10),
+Build-Depends: debhelper-compat (=13), libz-dev, libglib2.0-dev (>= 2.10),
  gettext, libgnutls28-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://github.com/kilobyte/kbtin
 Vcs-Git: https://github.com/kilobyte/kbtin.git -b debian
 Vcs-Browser: https://github.com/kilobyte/kbtin/tree/debian

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,8 @@
 
 override_dh_autoreconf:
 	touch README
-	dh_autoreconf
+	dpkg-parsechangelog -SVersion|rev|cut -d- -f2-|rev >VERSION
+	dh_autoreconf ./autogen.sh
 
 override_dh_auto_build:
 	V=y dh_auto_build
@@ -31,4 +32,5 @@
 override_dh_auto_clean:
 	rm -f tests/tests.at
 	rm -f README README.md .travis.yml
+	rm -f VERSION
 	dh_auto_clean

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v(\d\S*)\.tar\.gz/@PACKAGE@-$1\.tar\.gz/ \
  https://github.com/kilobyte/@PACKAGE@/tags .*/v(\d\S*)\.tar\.gz

## kbtin 1.0.26

=== debian/changelog ===
kbtin (1.0.26-3) unstable; urgency=medium

  * Disable the true positive test fail on ppc64el.  I have no Ubuntu
    porterbox and the bug doesn't repro on Debian.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 19 Jan 2022 20:14:41 +0100

kbtin (1.0.26-2) unstable; urgency=medium

  * Fix a crash on ppc64el (somehow reproducible on Ubuntu only).

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 14 Jan 2022 00:23:57 +0100

kbtin (1.0.26-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 06 Jan 2022 21:02:57 +0100

kbtin (1.0.25-1) unstable; urgency=medium

  * New upstream release.
  * The build system is now cmake.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 22 Dec 2021 21:59:52 +0100

kbtin (1.0.24-1) unstable; urgency=medium

  * New upstream release.
  * Drop B-Dep on gettext.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 24 Aug 2021 03:09:24 +0200

kbtin (1.0.23-1) experimental; urgency=medium

  * New upstream release.
  * Drop B-Dep on glib.
  * Drop upstream signing key.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 18 May 2021 00:22:39 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,8 @@
 Section: text
 Priority: optional
 Maintainer: Adam Borowski <kilobyte@angband.pl>
-Build-Depends: debhelper-compat (=13), libz-dev, libglib2.0-dev (>= 2.10),
- gettext, libgnutls28-dev
-Standards-Version: 4.5.1
+Build-Depends: debhelper-compat (=13), libz-dev, libgnutls28-dev, cmake
+Standards-Version: 4.6.0
 Homepage: https://github.com/kilobyte/kbtin
 Vcs-Git: https://github.com/kilobyte/kbtin.git -b debian
 Vcs-Browser: https://github.com/kilobyte/kbtin/tree/debian

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
	dh $@

override_dh_auto_configure:
ifneq (,$(findstring ppc64,$(DEB_HOST_ARCH)))
	rm -f 'tests/data/infinite hook send.'*
endif
	dpkg-parsechangelog -SVersion|rev|cut -d- -f2-|rev >VERSION
	dh_auto_configure

override_dh_auto_install:
	dh_auto_install
	tic terminfo.src -o $(CURDIR)/debian/kbtin/usr/share/terminfo

=== debian/tests/control ===
Tests: show

## kbtin 2.0

=== debian/changelog ===
kbtin (2.0-2) unstable; urgency=medium

  * Re-disable broken-on-Ubuntu tests on ppc64el.
  * Avoid unaligned usage, fixes FTBFS on sparc64.

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 19 Jun 2022 08:27:22 +0200

kbtin (2.0-1) unstable; urgency=medium

  * New upstream release.
  * New B-Deps: lib{hype,vecto}rscan, valgrind-dev.
  * Re-enable tests on ppc64el.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 17 Jun 2022 01:55:54 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,9 @@
 Section: text
 Priority: optional
 Maintainer: Adam Borowski <kilobyte@angband.pl>
-Build-Depends: debhelper-compat (=13), libz-dev, libgnutls28-dev, cmake
+Build-Depends: debhelper-compat (=13), libz-dev, libgnutls28-dev, cmake,
+	libhyperscan-dev [amd64 i386], libvectorscan-dev [arm64 ppc64el],
+	valgrind-if-available
 Standards-Version: 4.6.0
 Homepage: https://github.com/kilobyte/kbtin
 Vcs-Git: https://github.com/kilobyte/kbtin.git -b debian

## kbtin 2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -41,6 +41,11 @@
 	set(CMAKE_REQUIRED_LIBRARIES util)
 	set(libs ${libs} util)
 endif()
+CHECK_LIBRARY_EXISTS(hs hs_compile "" HAVE_HS)
+if (HAVE_HS)
+	set(CMAKE_REQUIRED_LIBRARIES hs)
+	set(libs ${libs} hs)
+endif()
 
 CHECK_INCLUDE_FILES(valgrind/valgrind.h HAVE_VALGRIND_VALGRIND_H)
 CHECK_INCLUDE_FILES(unistd.h HAVE_UNISTD_H)
@@ -68,7 +73,7 @@
 if (MCCP)
 	CHECK_LIBRARY_EXISTS(z gzread "" HAVE_LIB_ZLIB)
 	if (NOT HAVE_LIB_ZLIB)
-		message(FATAL_ERROR "MCCP compression requires zlib")
+		message(FATAL_ERROR "MCCP compression requires zlib ('cmake . -DMCCP=off' to disable)")
 	endif()
 	set(HAVE_ZLIB 1)
 	set(libs ${libs} z)
@@ -78,7 +83,7 @@
 
 if (SSL)
 	if (NOT GNUTLS_FOUND)
-		message(FATAL_ERROR "SSL encryption requires libgnutls")
+		message(FATAL_ERROR "SSL encryption requires libgnutls ('cmake . -DSSL=off' to disable")
 	endif()
 	set(HAVE_GNUTLS 1)
 	include_directories(SYSTEM ${GNUTLS_INCLUDE_DIR})
@@ -100,7 +105,6 @@
 	highlight.c
 	history.c
 	eval.c
-	llist.c
 	main.c
 	misc.c
 	net.c
@@ -134,6 +138,7 @@
 	slist.c
 	lists.c
 	vars.c
+	tlist.c
 )
 
 set(protos ${KBtin_sources})

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -21,3 +21,6 @@
 	add_test(NAME ${tn}
 		COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/runtest.sh "${t}")
 endforeach()
+
+add_executable(kbitr kbitr.c)
+add_test(NAME kbtree_itr COMMAND ${CMAKE_CURRENT_BINARY_DIR}/kbitr)

=== debian/changelog ===
kbtin (2.1-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:10:10 +1100

kbtin (2.1-2build1) noble; urgency=medium

  * No-change rebuild against libgnutls30t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 10 Mar 2024 02:06:47 +0000

kbtin (2.1-2) unstable; urgency=medium

  * Merge a bunch of fixes.
  * Don't use vectorscan on ppc64el, it's experimental/broken.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 28 Dec 2022 01:21:15 +0100

kbtin (2.1-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 06 Nov 2022 22:54:11 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: kbtin
 Section: text
 Priority: optional
-Maintainer: Adam Borowski <kilobyte@angband.pl>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Adam Borowski <kilobyte@angband.pl>
 Build-Depends: debhelper-compat (=13), libz-dev, libgnutls28-dev, cmake,
-	libhyperscan-dev [amd64 i386], libvectorscan-dev [arm64 ppc64el],
+	libhyperscan-dev [amd64 i386], libvectorscan-dev [arm64],
 	valgrind-if-available
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/kilobyte/kbtin
 Vcs-Git: https://github.com/kilobyte/kbtin.git -b debian
 Vcs-Browser: https://github.com/kilobyte/kbtin/tree/debian

## kbtin 2.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8.12)
+cmake_minimum_required(VERSION 2.8.12...3.27)
 if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.12)
 	cmake_policy(SET CMP0075 NEW) # hush the warning, either option works
 endif()
@@ -9,6 +9,7 @@
 include(CheckIncludeFiles)
 include(CheckLibraryExists)
 include(CheckFunctionExists)
+include(CheckSymbolExists)
 include(FindIconv)
 include(FindGnuTLS)
 include(GNUInstallDirs)
@@ -42,13 +43,9 @@
 	set(libs ${libs} util)
 endif()
 CHECK_LIBRARY_EXISTS(hs hs_compile "" HAVE_HS)
-if (HAVE_HS)
-	set(CMAKE_REQUIRED_LIBRARIES hs)
-	set(libs ${libs} hs)
-endif()
+option(SIMD "fast pattern matching via hyperscan" ${HAVE_HS})
 
 CHECK_INCLUDE_FILES(valgrind/valgrind.h HAVE_VALGRIND_VALGRIND_H)
-CHECK_INCLUDE_FILES(unistd.h HAVE_UNISTD_H)
 CHECK_INCLUDE_FILES(termios.h HAVE_TERMIOS_H)
 CHECK_INCLUDE_FILES(stropts.h HAVE_STROPTS_H)
 CHECK_FUNCTION_EXISTS(openpty HAVE_OPENPTY)
@@ -62,6 +59,7 @@
 CHECK_FUNCTION_EXISTS(posix_openpt HAVE_POSIX_OPENPT)
 CHECK_FUNCTION_EXISTS(strlcpy HAVE_STRLCPY)
 CHECK_FUNCTION_EXISTS(wcwidth HAVE_WCWIDTH)
+CHECK_SYMBOL_EXISTS(getentropy "unistd.h" HAVE_GETENTROPY)
 
 if(Iconv_FOUND)
 	include_directories(SYSTEM ${Iconv_INCLUDE_DIRS})
@@ -91,6 +89,18 @@
 else()
 	unset(HAVE_GNUTLS)
 endif()
+
+if (SIMD)
+	if (NOT HAVE_HS)
+		message(FATAL_ERROR "SIMD requires hyperscan/vectorscan")
+	endif()
+	set(CMAKE_REQUIRED_LIBRARIES hs)
+	set(libs ${libs} hs)
+	set(HAVE_SIMD 1)
+else()
+	unset(HAVE_SIMD)
+endif()
+
 
 configure_file(config.h.cmake ${CMAKE_BINARY_DIR}/config.h)
 include_directories(${CMAKE_BINARY_DIR})
@@ -139,6 +149,8 @@
 	lists.c
 	vars.c
 	tlist.c
+	mudcolors.c
+	ratelimit.c
 )
 
 set(protos ${KBtin_sources})

=== debian/changelog ===
kbtin (2.3-1) unstable; urgency=medium

  * New upstream release.
  * Add ca-certificates to Recommends.
  * Temporarily disable stack-clash-protection on armhf, it does accesses
    past SP not currently allowed by valgrind.  Thanks Emanuele Rocca,
    closes: #1061076.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 18 Jan 2024 10:53:48 +0100

=== debian/control ===
Source: kbtin
Section: text
Priority: optional
Maintainer: Adam Borowski <kilobyte@angband.pl>
Build-Depends: debhelper-compat (=13), libz-dev, libgnutls28-dev, cmake,
	libhyperscan-dev [amd64 i386], libvectorscan-dev [arm64],
	valgrind-if-available
Standards-Version: 4.7.2
Homepage: https://git.sr.ht/~kilobyte/kbtin
Vcs-Git: https://git.sr.ht/~kilobyte/kbtin.git -b debian
Vcs-Browser: https://git.sr.ht/~kilobyte/kbtin/tree/debian
Rules-Requires-Root: no

Package: kbtin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: colorized-logs, ca-certificates
Description: tintin++ style text-based MUD client
 KBtin is a console MUD client based on the once-popular tintin++.
 It is not limited for mudding, and can be used for running line-based local
 programs like adventure, mysqlclient, dpkg-buildpackage or piuparts.

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,11 @@
 #!/usr/bin/make -f
-export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
+
+ifeq ($(DEB_TARGET_ARCH),armhf)
+  export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-stackclash
+else
+  export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+endif
 
 %:
 	dh $@
